SLH-DSA for JOSE and COSE
Internet-Draft draft-ietf-cose-sphincs-plus-05
Michael Prorock
mesur.io
mprorock@mesur.io
Orie Steele
Transmute
orie@transmute.industries
Rafael Misoczki
Google
rafaelmisoczki@google.com
Michael Osborne
IBM
osb@zurich.ibm.com
Christine Cloostermans
NXP
christine.cloostermans@nxp.com
20 October 2024
Security
CBOR Object Signing and Encryption
JOSE
COSE
PQC
SPHINCS+
SLH-DSA
This document describes JOSE and COSE serializations for SLH-DSA, which was derived from SPHINCS+, a Post-Quantum Cryptography (PQC) based digital signature scheme. This document does not define any new cryptography, only seralizations of existing cryptographic systems described in [FIPS-205]. Note to RFC Editor: This document should not proceed to AUTH48 until NIST completes paramater tuning and selection as a part of the PQC standardization process.
About This Document
The latest revision of this draft can be found at https://cose-wg.github.io/draft-ietf-cose-sphincs-plus/draft-ietf-cose-sphincs-plus.html. Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-cose-sphincs-plus/.
Discussion of this document takes place on the CBOR Object Signing and Encryption Working Group mailing list (mailto:cose@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/cose/. Subscribe at https://www.ietf.org/mailman/listinfo/cose/.
Source for this draft and an issue tracker can be found at https://github.com/cose-wg/draft-ietf-cose-sphincs-plus.
Introduction
This document describes JSON Object Signing and Encryption (JOSE) and CBOR Object Signing and Encryption (COSE) serializations for the Stateless Hash-Based Digital Signature Standard (SLH-DSA), which was derived from Version 3.1 of SPHINCS+, a Post-Quantum Cryptography (PQC) based digital signature scheme.
This document does not define any new cryptography, only serializations of existing cryptographic systems described in [FIPS-205].
This document builds on the Algorithm Key Pair (AKP) type as defined in [I-D.draft-ietf-cose-dilithium]. The AKP type enables flexible representation of keys used across different post-quantum cryptographic algorithms, including SLH-DSA.
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The SLH-DSA Algorithm Family
The SLH-DSA Signature Scheme is parameterized to support different security levels.
This document requests the registration of the following algorithms in [IANA.jose]:
JOSE algorithms for SLH-DSA
Name | alg | Description
SLH-DSA-SHA2-128s | SLH-DSA-SHA2-128s | JSON Web Signature Algorithm for SLH-DSA-SHA2-128s
SLH-DSA-SHAKE-128s | SLH-DSA-SHAKE-128s | JSON Web Signature Algorithm for SLH-DSA-SHAKE-128s
SLH-DSA-SHA2-128f | SLH-DSA-SHA2-128f | JSON Web Signature Algorithm for SLH-DSA-SHA2-128f
This document requests the registration of the following algorithms in [IANA.cose]:
COSE algorithms for SLH-DSA
Name | alg | Description
SLH-DSA-SHA2-128s | TBD (requested assignment -51) | CBOR Object Signing Algorithm for SLH-DSA-SHA2-128s
SLH-DSA-SHAKE-128s | TBD (requested assignment -52) | CBOR Object Signing Algorithm for SLH-DSA-SHAKE-128s
SLH-DSA-SHA2-128f | TBD (requested assignment -53) | CBOR Object Signing Algorithm for SLH-DSA-SHA2-128f
SLH-DSA Keys
Private and Public Keys are produced to enable the sign and verify operations for each of the SLH-DSA Algorithms. The SLH-DSA Algorithm Family uses the Algorithm Key Pair (AKP) key type, as defined in [I-D.draft-ietf-cose-dilithium]. This ensures compatibility across different cryptographic algorithms that use AKP for key representation.
The specific algorithms for SLH-DSA, such as SLH-DSA-SHA2-128s, SLH-DSA-SHAKE-128s, and SLH-DSA-SHA2-128f, are defined in this document and are used in the alg value of an AKP key representation to specify the algorithm that corresponds to the key. Like ML-DSA keys, SLH-DSA keys use the AKP Key Type.
The thumbprints for SLH-DSA keys are also computed according to the process described in [I-D.draft-ietf-cose-dilithium]
Security Considerations
The security considerations of [RFC7515], [RFC7517] and [RFC9053] applies to this specification as well.
A detailed security analysis of SLH-DSA is beyond the scope of this specification, see [FIPS-205] for additional details.
The following considerations apply to all parameter sets described in this specification.
Validating public keys
All algorithms in that operate on public keys require first validating those keys. For the sign, verify and proof schemes, the use of KeyValidate is REQUIRED.
Side channel attacks
Implementations of the signing algorithm SHOULD protect the secret key from side-channel attacks. Multiple best practices exist to protect against side-channel attacks. Any implementation of the SLH-DSA signing algorithms SHOULD utilize the following best practices at a minimum:
- Constant timing - the implementation should ensure that constant time is utilized in operations
- Sequence and memory access persistance - the implementation SHOULD execute the exact same sequence of instructions (at a machine level) with the exact same memory access independent of which polynomial is being operated on.
- Uniform sampling - care should be given in implementations to preserve the property of uniform sampling in implementation and to prevent information leakage.
Randomness considerations
It is recommended that the all nonces are from a trusted source of randomness.
IANA Considerations
Additions to Existing Registries
New COSE Algorithms
IANA is requested to add the following entries to the COSE Algorithms Registry. The following completed registration templates are provided as described in RFC9053 and RFC9054.
SLH-DSA-SHA2-128s
- Name: SLH-DSA-SHA2-128s
- Value: TBD (requested assignment -51)
- Description: CBOR Object Signing Algorithm for SLH-DSA-SHA2-128s
- Capabilities: [kty]
- Reference: RFC XXXX
- Recommended: Yes
SLH-DSA-SHAKE-128s
- Name: SLH-DSA-SHAKE-128s
- Value: TBD (requested assignment -52)
- Description: CBOR Object Signing Algorithm for SLH-DSA-SHAKE-128s
- Capabilities: [kty]
- Reference: RFC XXXX
- Recommended: Yes
SLH-DSA-SHA2-128f
- Name: SLH-DSA-SHA2-128f
- Value: TBD (requested assignment -53)
- Description: CBOR Object Signing Algorithm for SLH-DSA-SHA2-128f
- Capabilities: [kty]
- Reference: RFC XXXX
- Recommended: Yes
New JOSE Algorithms
IANA is requested to add the following entries to the JSON Web Signature and Encryption Algorithms Registry. The following completed registration templates are provided as described in RFC7518.
SLH-DSA-SHA2-128s
- Algorithm Name: SLH-DSA-SHA2-128s
- Algorithm Description: SLH-DSA-SHA2-128s as described in FIPS 205.
- Algorithm Usage Location(s): alg
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Value registry: [IANA.jose] Algorithms
- Specification Document(s): RFC XXXX
- Algorithm Analysis Documents(s): [FIPS-205]
SLH-DSA-SHAKE-128s
- Algorithm Name: SLH-DSA-SHAKE-128s
- Algorithm Description: SLH-DSA-SHAKE-128s as described in FIPS 205.
- Algorithm Usage Location(s): alg
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Value registry: [IANA.jose] Algorithms
- Specification Document(s): RFC XXXX
- Algorithm Analysis Documents(s): [FIPS-205]
SLH-DSA-SHA2-128f
- Algorithm Name: SLH-DSA-SHA2-128f
- Algorithm Description: SLH-DSA-SHA2-128f as described in FIPS 205.
- Algorithm Usage Location(s): alg
- JOSE Implementation Requirements: Optional
- Change Controller: IETF
- Value registry: [IANA.jose] Algorithms
- Specification Document(s): RFC XXXX
- Algorithm Analysis Documents(s): [FIPS-205]
References
Normative References
[IANA.jose]

JSON Object Signing and Encryption (JOSE)
IANA
[IANA.cose]

CBOR Object Signing and Encryption (COSE)
IANA
[RFC7515]

JSON Web Signature (JWS)
M. Jones
J. Bradley
N. Sakimura
May 2015
RFC 7515
DOI 10.17487/RFC7515
[RFC7517]

JSON Web Key (JWK)
M. Jones
May 2015
RFC 7517
DOI 10.17487/RFC7517
[RFC9053]

CBOR Object Signing and Encryption (COSE): Initial Algorithms
J. Schaad
August 2022
RFC 9053
DOI 10.17487/RFC9053
[I-D.draft-ietf-cose-dilithium]

ML-DSA for JOSE and COSE
Michael Prorock
mesur.io
Orie Steele
Transmute
Rafael Misoczki
Google
Michael Osborne
IBM
Christine Cloostermans
NXP
20 October 2024
Internet-Draft draft-ietf-cose-dilithium-04
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[FIPS-205]

Stateless Hash-Based Digital Signature Standard
n.d.
[NIST-PQC-2022]

Selected Algorithms 2022
n.d.
Examples
JOSE
Key Pair
Example SLH-DSA-SHA2-128s Private JSON Web Key

{
  "kty": "AKP",
  "alg": "SLH-DSA-SHA2-128s",
  "pub": "V53SIdVF...uvw2nuCQ",
  "priv": "V53SIdVF...cDKLbsBY"
}

Example SLH-DSA-SHA2-128s Public JSON Web Key

{
  "kty": "AKP",
  "alg": "SLH-DSA-SHA2-128s",
  "pub": "V53SIdVF...uvw2nuCQ"
}

Thumbprint
The thumbprint is computed as described in
JSON Web Signature
Example SLH-DSA-SHA2-128s Decoded Protected Header

{
  "alg": "SLH-DSA-SHA2-128s"
}

Example SLH-DSA-SHA2-128s Compact JSON Web Signature

eyJhbGciOiJ...LCJraWQiOiI0MiJ9\
.\
eyJpc3MiOiJ1cm46d...XVpZDo0NTYifQ\
.\
5MSEgQ0dZB4SeLC...AAAAAABIhMUE

COSE
Key Pair
Example SLH-DSA-SHA2-128s Public COSE Key

{                                   / COSE Key                    /
  1: 7,                             / AKP Key Type                /
  3: -51,                           / SLH-DSA-SHA2-128s Algorithm /
  -1: h'7803c0f9...3f6e2c70',       / AKP Private Key             /
  -2: h'7803c0f9...3bba7abd',       / AKP Public Key              /
}
~~~
{: #SLH-DSA-SHA2-128s-private-cose-key title="Example SLH-DSA-SHA2-128s Private COSE Key"}

~~~~ cbor-diag
{                                   / COSE Key                    /
  1: 7,                             / AKP Key Type                /
  3: -51,                           / SLH-DSA-SHA2-128s Algorithm /
  -2: h'7803c0f9...3bba7abd',       / AKP Public Key              /
}

Thumbprint URI
TODO
COSE Sign 1
Example SLH-DSA-SHA2-128s COSE Sign 1

/ cose-sign1 / 18(
  [
    / protected / <<{
      / algorithm / 1 : -51 / SLH-DSA-SHA2-128s /
    }>>
    / unprotected / {},
    / payload / h'66616b65',
    / signature / h'53e855e8...0f263549'
  ]
)

Acknowledgments
TODO acknowledge.